#include "stdafx.h"

#include "core.h"

#include <afxpriv.h>

const int HIMETRIC_INCH	= 2540;


static UINT dss_GetList[] = {SPI_GETLOWPOWERTIMEOUT, 
    SPI_GETPOWEROFFTIMEOUT, SPI_GETSCREENSAVETIMEOUT};
static UINT dss_SetList[] = {SPI_SETLOWPOWERTIMEOUT, 
    SPI_SETPOWEROFFTIMEOUT, SPI_SETSCREENSAVETIMEOUT};


HBITMAP ExtractBitmap(IPicture* pPicture, COLORREF crBack)
{
	ASSERT(pPicture);

	if (!pPicture)
		return NULL;

	CBitmap bmMem;
	CDC dcMem;
	CDC* pDC = CWnd::GetDesktopWindow()->GetDC();

	if (dcMem.CreateCompatibleDC(pDC))
	{
		long hmWidth;
		long hmHeight;

		pPicture->get_Width(&hmWidth);
		pPicture->get_Height(&hmHeight);
		
		int nWidth	= MulDiv(hmWidth, pDC->GetDeviceCaps(LOGPIXELSX), HIMETRIC_INCH);
		int nHeight	= MulDiv(hmHeight, pDC->GetDeviceCaps(LOGPIXELSY), HIMETRIC_INCH);

		if (bmMem.CreateCompatibleBitmap(pDC, nWidth, nHeight))
		{
			CBitmap* pOldBM = dcMem.SelectObject(&bmMem);

			if (crBack != -1)
				dcMem.FillSolidRect(0, 0, nWidth, nHeight, crBack);
			
			HRESULT hr = pPicture->Render(dcMem, 0, 0, nWidth, nHeight, 0, hmHeight, hmWidth, -hmHeight, NULL);
			dcMem.SelectObject(pOldBM);
		}
	}

	CWnd::GetDesktopWindow()->ReleaseDC(pDC);

	return (HBITMAP)bmMem.Detach();
}

BOOL CORE_LoadBitmapFromFile(LPCTSTR cszPath, CBitmap &bitmap)
{
	CString cszThePath = cszPath;
	//if(cszThePath.Find(".bmp") > -1)
	//{
		HBITMAP m_hbitmap=(HBITMAP)LoadImage( AfxGetApp()->m_hInstance, cszThePath, IMAGE_BITMAP, 0,0,LR_LOADFROMFILE);
		
		if(m_hbitmap == NULL)
		{
			//then try to load the jpg version
			cszThePath.Replace(".bmp", ".jpg");
			USES_CONVERSION;
			COLORREF crBack = -1;
			IPicture* pPicture = NULL;
			
			m_hbitmap = NULL;
			HRESULT hr = OleLoadPicturePath(T2OLE(cszThePath), NULL, 0, crBack, IID_IPicture, (LPVOID*)&pPicture);
			
			if (pPicture)
			{
				m_hbitmap = ExtractBitmap(pPicture, crBack);
				pPicture->Release();
			}
			
		}

		if (m_hbitmap == NULL)
			return FALSE;
		
		if (bitmap.Attach(m_hbitmap)==FALSE)
			return FALSE;
		
	/*}
	else
	{
		USES_CONVERSION;
		COLORREF crBack = -1;
		IPicture* pPicture = NULL;
		
		HBITMAP hbm = NULL;
		HRESULT hr = OleLoadPicturePath(T2OLE(cszPath), NULL, 0, crBack, IID_IPicture, (LPVOID*)&pPicture);
		
		if (pPicture)
		{
			hbm = ExtractBitmap(pPicture, crBack);
			pPicture->Release();
		}
		
		if (hbm == NULL)
			return FALSE;
		
		if (bitmap.Attach(hbm)==FALSE)
			return FALSE;
	}*/


	
	return TRUE;
}



HBITMAP CORE_HLoadBitmapFromFile(LPCTSTR cszPath, CBitmap &bitmap)
{
	CString cszThePath = cszPath;
	//if(cszThePath.Find(".bmp") > -1)
	//{
		HBITMAP m_hbitmap=(HBITMAP)LoadImage( AfxGetApp()->m_hInstance, cszThePath, IMAGE_BITMAP, 0,0,LR_LOADFROMFILE);
		
		if(m_hbitmap == NULL)
		{
			//then try to load the jpg version
			cszThePath.Replace(".bmp", ".jpg");
			USES_CONVERSION;
			COLORREF crBack = -1;
			IPicture* pPicture = NULL;
			
			m_hbitmap = NULL;
			HRESULT hr = OleLoadPicturePath(T2OLE(cszThePath), NULL, 0, crBack, IID_IPicture, (LPVOID*)&pPicture);
			
			if (pPicture)
			{
				m_hbitmap = ExtractBitmap(pPicture, crBack);
				pPicture->Release();
			}
			
		}

		if (m_hbitmap == NULL)
			return NULL;
		
		if (bitmap.Attach(m_hbitmap)==FALSE)
			return NULL;


	
	return m_hbitmap;
}

