// DAC2.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "DAC2.h"

UINT aryLargeNumbers[10] = {IDB_LARGE_ZERO, IDB_LARGE_ONE, IDB_LARGE_TWO, IDB_LARGE_THREE, IDB_LARGE_FOUR, IDB_LARGE_FIVE, IDB_LARGE_SIX, IDB_LARGE_SEVEN, IDB_LARGE_EIGHT, IDB_LARGE_NINE};
UINT arySmallNumbers[10] = {IDB_SMALL_ZERO, IDB_SMALL_ONE, IDB_SMALL_TWO, IDB_SMALL_THREE, IDB_SMALL_FOUR, IDB_SMALL_FIVE, IDB_SMALL_SIX, IDB_SMALL_SEVEN, IDB_SMALL_EIGHT, IDB_SMALL_NINE};

void CALLBACK DeckAPlayFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckA_SetPlayLightB(!bDeckAPlayLightOn);
}

void CALLBACK DeckBPlayFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckB_SetPlayLightB(!bDeckBPlayLightOn);
}

void CALLBACK DeckACueFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckA_SetCueLightB(!bDeckACueLightOn);
	TRACE("LIGHT: %d\n", bDeckACueLightOn);
}

void CALLBACK DeckBCueFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckB_SetCueLightB(!bDeckBCueLightOn);
}

BOOL WINEXPORT DAC2_EventCallbackSet(DAC2PROC* proca, DAC2PROC* procb, DWORD user)
{
	if(bInitialized)
	{
		m_proca = proca;
		m_procb = procb;
		m_dwUser = user;
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

void CALLBACK DAC2ListenerDeckA(CString cszCode, BYTE dataarray[])
{
	if(cszCode == "905B407F")
	{
		//load down
		m_proca(DAC2_LOAD_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "905B007F")
	{
		//load up
		m_proca(DAC2_LOAD_UP, 0, m_dwUser);
	}
	else if(cszCode == "9051407F")
	{
		//cue down
		m_proca(DAC2_CUE_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9051007F")
	{
		//cue up
		m_proca(DAC2_CUE_UP, 0, m_dwUser);
	}
	else if(cszCode == "9050407F")
	{
		//play down
		m_proca(DAC2_PLAY_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9050007F")
	{
		//play up
		m_proca(DAC2_PLAY_UP, 0, m_dwUser);
	}
	else if(cszCode == "9055407F")
	{
		//waitlist down
		m_proca(DAC2_WAIT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9055007F")
	{
		//waitlist up
		m_proca(DAC2_WAIT_UP, 0, m_dwUser);
	}
	else if(cszCode == "905A407F")
	{
		//shift down
		m_proca(DAC2_SHIFT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "905A007F")
	{
		//shift up
		m_proca(DAC2_SHIFT_UP, 0, m_dwUser);
	}
	else if(cszCode == "905C407F")
	{
		//fx down
		m_proca(DAC2_FX_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "905C007F")
	{
		//fx up
		m_proca(DAC2_FX_UP, 0, m_dwUser);
	}
	else if(cszCode == "9056407F")
	{
		//cue left down
		m_proca(DAC2_CUE_LEFT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9056007F")
	{
		//cue left up
		m_proca(DAC2_CUE_LEFT_UP, 0, m_dwUser);
	}
	else if(cszCode == "9058407F")
	{
		//cue right down
		m_proca(DAC2_CUE_RIGHT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9058007F")
	{
		//cue rght up
		m_proca(DAC2_CUE_RIGHT_UP, 0, m_dwUser);
	}
	else if(cszCode == "9057407F")
	{
		//group down
		m_proca(DAC2_GROUP_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9057007F")
	{
		//group up
		m_proca(DAC2_GROUP_UP, 0, m_dwUser);
	}
	else if(cszCode == "9059407F")
	{
		//loop down
		m_proca(DAC2_LOOP_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9059007F")
	{
		//loop up
		m_proca(DAC2_LOOP_UP, 0, m_dwUser);
	}
	else if(cszCode == "9052407F")
	{
		//match down
		m_proca(DAC2_MATCH_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9052007F")
	{
		//match up
		m_proca(DAC2_MATCH_UP, 0, m_dwUser);
	}
	else if(cszCode == "9053407F")
	{
		//pitch bend plus down
		m_proca(DAC2_PITCHBEND_PLUS_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9053007F")
	{
		//pitch bend plus up
		m_proca(DAC2_PITCHBEND_PLUS_UP, 0, m_dwUser);
	}
	else if(cszCode == "9054407F")
	{
		//pitch bend minus down
		m_proca(DAC2_PITCHBEND_MINUS_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9054007F")
	{
		//pitch bend minus up
		m_proca(DAC2_PITCHBEND_MINUS_UP, 0, m_dwUser);
	}
	else if(cszCode == "9061207F")
	{
		//jog left
		m_proca(DAC2_JOG_LEFT, 0, m_dwUser);
	}
	else if(cszCode == "9061307F")
	{
		//jog right
		m_proca(DAC2_JOG_RIGHT, 0, m_dwUser);
	}
	else if(cszCode.Mid(0,4) == "E003" && cszCode.GetLength() == 8)
	{
		DWORD nValue= (DWORD)dataarray[2];
		//pitch up
		m_proca(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(cszCode.Mid(0,4) == "E004" && cszCode.GetLength() == 8)
	{
		DWORD nValue= (DWORD)dataarray[2];
		nValue*=-1;
		//pitch down
		m_proca(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(cszCode == "9030007F")
	{
		//seek start
		m_proca(DAC2_SEEK_START, 0, m_dwUser);
	}
	else if(cszCode == "9030407F")
	{
		//seek end
		m_proca(DAC2_SEEK_END, 0, m_dwUser);
	}
	else if(cszCode == "9031407F")
	{
		//seek fwd code 1 on
		m_proca(DAC2_SEEK_FWD_1_ON, 0, m_dwUser);
	}
	else if(cszCode == "9031007F")
	{
		//seek fwd code 1 off
		m_proca(DAC2_SEEK_FWD_1_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9032407F")
	{
		//seek fwd code 2 on
		m_proca(DAC2_SEEK_FWD_2_ON, 0, m_dwUser);
	}
	else if(cszCode == "9032007F")
	{
		//seek fwd code 2 off
		m_proca(DAC2_SEEK_FWD_2_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9033407F")
	{
		//seek fwd code 3 on
		m_proca(DAC2_SEEK_FWD_3_ON, 0, m_dwUser);
	}
	else if(cszCode == "9033007F")
	{
		//seek fwd code 3 off
		m_proca(DAC2_SEEK_FWD_3_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9034407F")
	{
		//seek fwd code 4 on
		m_proca(DAC2_SEEK_FWD_4_ON, 0, m_dwUser);
	}
	else if(cszCode == "9034007F")
	{
		//seek fwd code 4 off
		m_proca(DAC2_SEEK_FWD_4_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9035407F")
	{
		//seek fwd code 5 on
		m_proca(DAC2_SEEK_FWD_5_ON, 0, m_dwUser);
	}
	else if(cszCode == "9035007F")
	{
		//seek fwd code 5 off
		m_proca(DAC2_SEEK_FWD_5_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9036407F")
	{
		//seek fwd code 6 on
		m_proca(DAC2_SEEK_FWD_6_ON, 0, m_dwUser);
	}
	else if(cszCode == "9036007F")
	{
		//seek fwd code 6 off
		m_proca(DAC2_SEEK_FWD_6_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9037407F")
	{
		//seek fwd code 7 on
		m_proca(DAC2_SEEK_FWD_7_ON, 0, m_dwUser);
	}
	else if(cszCode == "9037007F")
	{
		//seek fwd code 7 off
		m_proca(DAC2_SEEK_FWD_7_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9038407F")
	{
		//seek rev code 1 on
		m_proca(DAC2_SEEK_REV_1_ON, 0, m_dwUser);
	}
	else if(cszCode == "9038007F")
	{
		//seek rev code 1 off
		m_proca(DAC2_SEEK_REV_1_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9039407F")
	{
		//seek rev code 2 on
		m_proca(DAC2_SEEK_REV_2_ON, 0, m_dwUser);
	}
	else if(cszCode == "9039007F")
	{
		//seek rev code 2 off
		m_proca(DAC2_SEEK_REV_2_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903A407F")
	{
		//seek rev code 3 on
		m_proca(DAC2_SEEK_REV_3_ON, 0, m_dwUser);
	}
	else if(cszCode == "903A007F")
	{
		//seek rev code 3 off
		m_proca(DAC2_SEEK_REV_3_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903B407F")
	{
		//seek rev code 4 on
		m_proca(DAC2_SEEK_REV_4_ON, 0, m_dwUser);
	}
	else if(cszCode == "903B007F")
	{
		//seek rev code 4 off
		m_proca(DAC2_SEEK_REV_4_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903C407F")
	{
		//seek rev code 5 on
		m_proca(DAC2_SEEK_REV_5_ON, 0, m_dwUser);
	}
	else if(cszCode == "903C007F")
	{
		//seek rev code 5 off
		m_proca(DAC2_SEEK_REV_5_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903D407F")
	{
		//seek rev code 6 on
		m_proca(DAC2_SEEK_REV_6_ON, 0, m_dwUser);
	}
	else if(cszCode == "903D007F")
	{
		//seek rev code 6 off
		m_proca(DAC2_SEEK_REV_6_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903E407F")
	{
		//seek rev code 7 on
		m_proca(DAC2_SEEK_REV_7_ON, 0, m_dwUser);
	}
	else if(cszCode == "903E007F")
	{
		//seek rev code 7 off
		m_proca(DAC2_SEEK_REV_7_OFF, 0, m_dwUser);
	}
	else if(cszCode == "903F407F")
	{
		//seek rev code 8 on
		m_proca(DAC2_SEEK_REV_8_ON, 0, m_dwUser);
	}
	else if(cszCode == "903F007F")
	{
		//seek rev code 8 off
		m_proca(DAC2_SEEK_REV_8_OFF, 0, m_dwUser);
	}
}

void CALLBACK DAC2ListenerDeckB(CString cszCode, BYTE dataarray[])
{
	if(cszCode == "904B407F")
	{
		//load down
		m_procb(DAC2_LOAD_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "904B007F")
	{
		//load up
		m_procb(DAC2_LOAD_UP, 0, m_dwUser);
	}
	else if(cszCode == "9041407F")
	{
		//cue down
		m_procb(DAC2_CUE_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9041007F")
	{
		//cue up
		m_procb(DAC2_CUE_UP, 0, m_dwUser);
	}
	else if(cszCode == "9040407F")
	{
		//play down
		m_procb(DAC2_PLAY_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9040007F")
	{
		//play up
		m_procb(DAC2_PLAY_UP, 0, m_dwUser);
	}
	else if(cszCode == "9045407F")
	{
		//waitlist down
		m_procb(DAC2_WAIT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9045007F")
	{
		//waitlist up
		m_procb(DAC2_WAIT_UP, 0, m_dwUser);
	}
	else if(cszCode == "904A407F")
	{
		//shift down
		m_procb(DAC2_SHIFT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "904A007F")
	{
		//shift up
		m_procb(DAC2_SHIFT_UP, 0, m_dwUser);
	}
	else if(cszCode == "904C407F")
	{
		//fx down
		m_procb(DAC2_FX_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "904C007F")
	{
		//fx up
		m_procb(DAC2_FX_UP, 0, m_dwUser);
	}
	else if(cszCode == "9046407F")
	{
		//cue left down
		m_procb(DAC2_CUE_LEFT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9046007F")
	{
		//cue left up
		m_procb(DAC2_CUE_LEFT_UP, 0, m_dwUser);
	}
	else if(cszCode == "9048407F")
	{
		//cue right down
		m_procb(DAC2_CUE_RIGHT_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9048007F")
	{
		//cue rght up
		m_procb(DAC2_CUE_RIGHT_UP, 0, m_dwUser);
	}
	else if(cszCode == "9047407F")
	{
		//group down
		m_procb(DAC2_GROUP_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9047007F")
	{
		//group up
		m_procb(DAC2_GROUP_UP, 0, m_dwUser);
	}
	else if(cszCode == "9049407F")
	{
		//loop down
		m_procb(DAC2_LOOP_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9049007F")
	{
		//loop up
		m_procb(DAC2_LOOP_UP, 0, m_dwUser);
	}
	else if(cszCode == "9042407F")
	{
		//match down
		m_procb(DAC2_MATCH_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9042007F")
	{
		//match up
		m_procb(DAC2_MATCH_UP, 0, m_dwUser);
	}
	else if(cszCode == "9043407F")
	{
		//pitch bend plus down
		m_procb(DAC2_PITCHBEND_PLUS_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9043007F")
	{
		//pitch bend plus up
		m_procb(DAC2_PITCHBEND_PLUS_UP, 0, m_dwUser);
	}
	else if(cszCode == "9044407F")
	{
		//pitch bend minus down
		m_procb(DAC2_PITCHBEND_MINUS_DOWN, 0, m_dwUser);
	}
	else if(cszCode == "9044007F")
	{
		//pitch bend minus up
		m_procb(DAC2_PITCHBEND_MINUS_UP, 0, m_dwUser);
	}
	else if(cszCode == "9060207F")
	{
		//jog left
		m_procb(DAC2_JOG_LEFT, 0, m_dwUser);
	}
	else if(cszCode == "9060307F")
	{
		//jog right
		m_procb(DAC2_JOG_RIGHT, 0, m_dwUser);
	}
	else if(cszCode.Mid(0,4) == "E001" && cszCode.GetLength() == 8)
	{
		
		DWORD nValue= (DWORD)dataarray[2];
		//pitch up
		m_procb(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(cszCode.Mid(0,4) == "E002" && cszCode.GetLength() == 8)
	{
		DWORD nValue= (DWORD)dataarray[2];
		nValue*=-1;
		//pitch down
		m_procb(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(cszCode == "9020007F")
	{
		//seek start
		m_procb(DAC2_SEEK_START, 0, m_dwUser);
	}
	else if(cszCode == "9020407F")
	{
		//seek end
		m_procb(DAC2_SEEK_END, 0, m_dwUser);
	}
	else if(cszCode == "9021407F")
	{
		//seek fwd code 1 on
		m_procb(DAC2_SEEK_FWD_1_ON, 0, m_dwUser);
	}
	else if(cszCode == "9021007F")
	{
		//seek fwd code 1 off
		m_procb(DAC2_SEEK_FWD_1_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9022407F")
	{
		//seek fwd code 2 on
		m_procb(DAC2_SEEK_FWD_2_ON, 0, m_dwUser);
	}
	else if(cszCode == "9022007F")
	{
		//seek fwd code 2 off
		m_procb(DAC2_SEEK_FWD_2_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9023407F")
	{
		//seek fwd code 3 on
		m_procb(DAC2_SEEK_FWD_3_ON, 0, m_dwUser);
	}
	else if(cszCode == "9023007F")
	{
		//seek fwd code 3 off
		m_procb(DAC2_SEEK_FWD_3_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9024407F")
	{
		//seek fwd code 4 on
		m_procb(DAC2_SEEK_FWD_4_ON, 0, m_dwUser);
	}
	else if(cszCode == "9024007F")
	{
		//seek fwd code 4 off
		m_procb(DAC2_SEEK_FWD_4_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9025407F")
	{
		//seek fwd code 5 on
		m_procb(DAC2_SEEK_FWD_5_ON, 0, m_dwUser);
	}
	else if(cszCode == "9025007F")
	{
		//seek fwd code 5 off
		m_procb(DAC2_SEEK_FWD_5_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9026407F")
	{
		//seek fwd code 6 on
		m_procb(DAC2_SEEK_FWD_6_ON, 0, m_dwUser);
	}
	else if(cszCode == "9026007F")
	{
		//seek fwd code 6 off
		m_procb(DAC2_SEEK_FWD_6_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9027407F")
	{
		//seek fwd code 7 on
		m_procb(DAC2_SEEK_FWD_7_ON, 0, m_dwUser);
	}
	else if(cszCode == "9027007F")
	{
		//seek fwd code 7 off
		m_procb(DAC2_SEEK_FWD_7_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9028407F")
	{
		//seek rev code 1 on
		m_procb(DAC2_SEEK_REV_1_ON, 0, m_dwUser);
	}
	else if(cszCode == "9028007F")
	{
		//seek rev code 1 off
		m_procb(DAC2_SEEK_REV_1_OFF, 0, m_dwUser);
	}
	else if(cszCode == "9029407F")
	{
		//seek rev code 2 on
		m_procb(DAC2_SEEK_REV_2_ON, 0, m_dwUser);
	}
	else if(cszCode == "9029007F")
	{
		//seek rev code 2 off
		m_procb(DAC2_SEEK_REV_2_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902A407F")
	{
		//seek rev code 3 on
		m_procb(DAC2_SEEK_REV_3_ON, 0, m_dwUser);
	}
	else if(cszCode == "902A007F")
	{
		//seek rev code 3 off
		m_procb(DAC2_SEEK_REV_3_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902B407F")
	{
		//seek rev code 4 on
		m_procb(DAC2_SEEK_REV_4_ON, 0, m_dwUser);
	}
	else if(cszCode == "902B007F")
	{
		//seek rev code 4 off
		m_procb(DAC2_SEEK_REV_4_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902C407F")
	{
		//seek rev code 5 on
		m_procb(DAC2_SEEK_REV_5_ON, 0, m_dwUser);
	}
	else if(cszCode == "902C007F")
	{
		//seek rev code 5 off
		m_procb(DAC2_SEEK_REV_5_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902D407F")
	{
		//seek rev code 6 on
		m_procb(DAC2_SEEK_REV_6_ON, 0, m_dwUser);
	}
	else if(cszCode == "902D007F")
	{
		//seek rev code 6 off
		m_procb(DAC2_SEEK_REV_6_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902E407F")
	{
		//seek rev code 7 on
		m_procb(DAC2_SEEK_REV_7_ON, 0, m_dwUser);
	}
	else if(cszCode == "902E007F")
	{
		//seek rev code 7 off
		m_procb(DAC2_SEEK_REV_7_OFF, 0, m_dwUser);
	}
	else if(cszCode == "902F407F")
	{
		//seek rev code 8 on
		m_procb(DAC2_SEEK_REV_8_ON, 0, m_dwUser);
	}
	else if(cszCode == "902F007F")
	{
		//seek rev code 8 off
		m_procb(DAC2_SEEK_REV_8_OFF, 0, m_dwUser);
	}
}

DWORD WINAPI CommReader(void *pvData)
{
	
	DWORD dwEventMask;
    int   nSize;
    //char  byBuffer[1024];
	BYTE	byBuffer[1024]={0};
	
    // Set the event mask
    port->SetCommMask(EV_RXCHAR);
	
    // Tell the port to notify us when a read event occurs
    if(!port->WaitCommEvent())
        return 0xFFFFFFFF;      // Error
	
    // Wait for an empty Comm event that signals the COM port object
    // is shutting down.
    do
    {
        // Since this is a separate thread, we can pass TRUE so
        // that the function doesn't return until an event occurs.
        dwEventMask = port->CheckForCommEvent(TRUE);
        if(dwEventMask & EV_RXCHAR)
        {
            
				
			nSize = port->ReadCommBlock(byBuffer, 1024);
				
		

            if(nSize)
			{
				//TRACE("size %d\n", nSize);

				if(nSize >= 18)
				{
				
					//check if it is dac2 here
					CString cszResponse="";
					for(int i=0; i<nSize; i++)
					{
						cszResponse = cszResponse + (CString)byBuffer[i];
					}
					
					
					cszResponse.MakeUpper();
					if(cszResponse.Find("PCDJ DAC-2"))
					{
						bIsDAC2 = TRUE;
					}
					
				
				}
				
				
					
				
				int count = 0;
				while(nSize >= 4)
				{
					BYTE dataarray[4]={0};
					dataarray[0] = byBuffer[count];
					dataarray[1] = byBuffer[count+1];
					dataarray[2] = byBuffer[count+2];
					dataarray[3] = byBuffer[count+3];
					
					
					
					CString cszCode;
					cszCode.Format("%02X%02X%02X%02X", dataarray[0],dataarray[1],dataarray[2],dataarray[3]);
					
				
					
				
				
					
				}
					
				
				
				
			}
			// pDoc->ReceiveChars(byBuffer, nSize);
			
            // Set it up to wait for the next event
            port->WaitCommEvent();
        }
		
    } while(dwEventMask);
	
	return 0L;
}

BOOL WINEXPORT DAC2_AutoInit(BOOL bEmulate)
{
	TCHAR devices[65535]; 

	if(bEmulate)
		return DAC2_Init(NULL, TRUE);
	
	DWORD nChars = QueryDosDevice(NULL, devices, 65535); 
	
	if(nChars) 
		
	{ 
		
		int i = 0; 
		
		for(;;) 
			
		{ 
			
			TCHAR* pszCurrentDevice = &devices[i]; 
			
			size_t nLen = _tcslen(pszCurrentDevice); 
			
			if(nLen > 3 && _tcsnicmp(pszCurrentDevice, _T("COM"), 3) == 0) 
				
			{ 
				
				if( (pszCurrentDevice[3] >47) && (pszCurrentDevice[3] < 58) ) 
					
				{ 
					
					CString str; 
					
					int nPort = _ttoi(&pszCurrentDevice[3]); 
					
					str.Format("COM%d", nPort); 
					
					if(DAC2_Init(str, FALSE))
					{
						return TRUE;
					}
					
				} 
				
			} 
			
			while(devices[i] != _T('\0')) 
				
				i++; 
			
			i++; 
			
			if(devices[i] == _T('\0')) 
				
				break; 
			
		} 
		
	}
	
	return FALSE;
}

BOOL WINEXPORT DAC2_Init(LPCTSTR cszPort, BOOL bEmulate)
{
	BOOL bSuccess = FALSE;


	
	BOOL bStartThread = FALSE;
	LPCTSTR cszEmulate = "emulate";
	
	CString cszMyPort = cszPort;
	CString cszMyEmulate = cszEmulate;
	if(cszMyPort == cszMyEmulate || bEmulate)
	{
		bIsEmulatorMode = TRUE;
		if(!emulator)
		{
			
			emulator = new CEmulatorDlg();
			
			emulator->SetListenerCallback((DAC2LISTENER*)DAC2ListenerDeckA, (DAC2LISTENER*)DAC2ListenerDeckB);
			
			if(emulator)
			{
			
					
				CWnd dummywnd;
				emulator->Create(IDD_EMULATOR, &dummywnd);
				emulator->ShowWindow(SW_SHOW);
				

					
			}
		}

		if(cszPort == NULL)
		{
			bSuccess = TRUE;
			bInitialized = TRUE;
			return bSuccess;
		}
	}
	
	if(cszPort != NULL)
	{
		if(port)
			delete port;

		port = new CSerialPort(cszPort);
	}
	
	
	
	
	
	if(port && port->IsValid())
	{
		bStartThread = TRUE;
		
	

			if(bStartThread && !port->StartCommThread(CommReader, 0))
			{
				
				
	
				delete port;
				port = NULL;
				
				
				
				//delete emulator;
				//emulator = NULL;
				
				DAC2_ErrorCode = DAC2_ERROR_THREAD;
				bInitialized = FALSE;
			}
			else
			{
				//We are all good
			}
	


		
		
		//send init code to port
		char buf[] = {0xFF, 0x01, 0x01, 0x00}; 
		port->WriteByte(buf, 4);
		/*port->WriteByte(0xFF);
		port->WriteByte(0x01);
		port->WriteByte(0x01);*/
		
		//check for return value to make sure this
		//is the PCDJ DAC-2 and not something else
		//assume it is ok for now
		
		DWORD dwStart = GetTickCount();
		do
		{
			//do nothing
		}while(GetTickCount()-dwStart < 5000 && !bIsDAC2);
		
		if(bIsDAC2)
		{
			
			bInitialized = TRUE;
			bSuccess = TRUE;
		}
		else
		{
			if(port)
			{
				delete port;
				port = NULL;
				
			}
			
			/*if(emulator)
			{
			delete emulator;
			emulator = NULL;
		}*/
			
			DAC2_ErrorCode = DAC2_ERROR_DEVICE;
			bInitialized = FALSE;
		}
		
	}
	else
	{
		if(port)
		{
			delete port;
			port = NULL;
		}
		
		/*if(emulator)
		{
		delete emulator;
		emulator = NULL;
	}*/
		DAC2_ErrorCode = DAC2_ERROR_PORT;
		bInitialized = FALSE;
	}
	
    return bSuccess;
}

BOOL WINEXPORT DAC2_Free()
{
	if(bInitialized)
	{
		if(port)
		{
			delete port;
			port = NULL;
			
		}
		
		if(emulator && bIsEmulatorMode)
		{
			delete emulator;
			emulator = NULL;
		}
		
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

DWORD WINEXPORT DAC2_ErrorGetCode()
{
	return DAC2_ErrorCode;
}

//DECK A

BOOL WINEXPORT DAC2_DeckA_SetCueNumber(int nNumber)
{
	if(bInitialized)
	{
		//leftnum  900000-90000B
		//rightnum 900100-90010B
		if(nNumber == -1)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x00, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				char buf2[] = {0x90, 0x01, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckACueDigitOne.SetToggleBitmap("", IDB_LARGE_BLANK);
				emulator->DeckACueDigitOne.ToggleOn(TRUE);
				emulator->DeckACueDigitTwo.SetToggleBitmap("", IDB_LARGE_BLANK);
				emulator->DeckACueDigitTwo.ToggleOn(TRUE);
			}
			
		}
		else if(nNumber == -2)
		{
			//set them to - -
			if(port)
			{
				char buf[] = {0x90, 0x00, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x01, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckACueDigitOne.SetToggleBitmap("", IDB_LARGE_DASH);
				emulator->DeckACueDigitOne.ToggleOn(TRUE);
				emulator->DeckACueDigitTwo.SetToggleBitmap("", IDB_LARGE_DASH);
				emulator->DeckACueDigitTwo.ToggleOn(TRUE);
			}
			
		}
		else if(nNumber <= 99)
		{
			//set them to the number provided
			//ok get the number and parse it
			CString cszNumber;
			cszNumber.Format("%02d", nNumber);
			
			CString cszDigitOne = cszNumber.GetAt(0);
			CString cszDigitTwo = cszNumber.GetAt(1);
			
			BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
			BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x00, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x01, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				
				//figure out the bitmap
				emulator->DeckACueDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
				emulator->DeckACueDigitOne.ToggleOn(TRUE);
				emulator->DeckACueDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
				emulator->DeckACueDigitTwo.ToggleOn(TRUE);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetColons(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x0D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckATimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckATimeColonOne.ToggleOn(TRUE);
				
				emulator->DeckATimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckATimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckATimeColonTwo.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x0D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckATimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckATimeColonOne.ToggleOn(TRUE);
				
				emulator->DeckATimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckATimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckATimeColonTwo.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetTime(int nMinutes, int nSeconds, int nMilliseconds)
{
	if(bInitialized)
	{
		CString cszNumber;
		CString cszDigitOne, cszDigitTwo;
		BYTE xDigitOne, xDigitTwo;
		
		//minutes
		if(nMinutes == -1)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x02, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitOne.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitTwo.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else if(nMinutes == -2)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x02, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitOne.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitTwo.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else if(nMinutes <= 99)
		{
			cszNumber;
			cszNumber.Format("%02d", nMinutes);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x02, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitOne.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckATimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitTwo.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckATimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//seconds
		if(nSeconds == -1)
		{
			if(port)
			{
				char buf[] = {0x90, 0x04, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitThree.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitFour.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitFour.ToggleOn(TRUE);
			}
		}
		else if(nSeconds == -2)
		{
			if(port)
			{
				char buf[] = {0x90, 0x04, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitThree.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitFour.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitFour.ToggleOn(TRUE);
			}
		}
		else if(nSeconds <= 99)
		{
			cszNumber.Format("%02d", nSeconds);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x04, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitThree.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckATimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitFour.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckATimeDigitFour.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//milliseconds
		if(nMilliseconds == -1)
		{
		
			if(port)
			{
				char buf[] = {0x90, 0x06, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitFive.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitSix.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckATimeDigitSix.ToggleOn(TRUE);
			}
		}
		else if(nMilliseconds == -2)
		{
		
			if(port)
			{
				char buf[] = {0x90, 0x06, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitFive.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitSix.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckATimeDigitSix.ToggleOn(TRUE);
			}
		}
		else if(nMilliseconds <= 99)
		{
			cszNumber.Format("%02d", nMilliseconds);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			//TRACE("%02d\n",atoi(cszDigitOne), atoi(cszDigitTwo));
			if(port)
			{
				char buf[] = {0x90, 0x06, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckATimeDigitFive.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckATimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckATimeDigitSix.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckATimeDigitSix.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetElapsed(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAElapsed.SetToggleBitmap("", IDB_ELAPSED_ON);
				emulator->DeckAElapsed.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAElapsed.SetToggleBitmap("", IDB_ELAPSED_OFF);
				emulator->DeckAElapsed.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetRemain(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x07, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckARemain.SetToggleBitmap("", IDB_REMAIN_ON);
				emulator->DeckARemain.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x07, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckARemain.SetToggleBitmap("", IDB_REMAIN_OFF);
				emulator->DeckARemain.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetSingle(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckASingle.SetToggleBitmap("", IDB_SINGLE_ON);
				emulator->DeckASingle.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckASingle.SetToggleBitmap("", IDB_SINGLE_OFF);
				emulator->DeckASingle.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPitchNumber(int nNumber)
{
	if(bInitialized)
	{
		if(nNumber <= 199 && nNumber >= -199)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			CString cszDigitOne;
			CString cszDigitTwo;
			CString cszDigitThree;
			
			int nNumberCopy = nNumber;
			nNumber = abs(nNumber);
			
			
			CString cszNumber;
			cszNumber.Format("%02d", nNumber);
			
			int nLength = cszNumber.GetLength();
			
			//Clear the decimal
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x0E, 0x00}; 
				port->WriteByte(buf, 4);

			}
			
			if(emulator)
			{
				emulator->DeckAPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_OFF);
				emulator->DeckAPitchDecimal.ToggleOn(TRUE);
			}
			
			
			if(nLength == 3)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x08, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckAPitchDigitOne.ToggleOn(TRUE);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x09, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckAPitchDigitTwo.ToggleOn(TRUE);
				}
				
				
				if(port)
				{
					char buf3[] = {0x90, 0x0A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitThree)]);
					emulator->DeckAPitchDigitThree.ToggleOn(TRUE);
				}
				
				
				
			}
			else if(nLength == 2)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				
				//clear the 1
				//port->WriteByte(0x90);
				//port->WriteByte(0x08);
				//port->WriteByte(0x00);
				
				if(port)
				{
					//clear the 1
					char buf[] = {0x90, 0x08, 0x02, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(emulator)
				{
					emulator->DeckAPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckAPitchDigitOne.ToggleOn(FALSE);
				}



				if(port)
				{

					char buf[] = {0x90, 0x09, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{

					emulator->DeckAPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckAPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x0A, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckAPitchDigitThree.ToggleOn(TRUE);
				}
			}
			
			
			if(nNumberCopy < 0)
			{
				if(nLength == 3)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckAPitchNegative.ToggleOn(TRUE);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
						emulator->DeckAPitchDigitOne.ToggleOn(TRUE);
					}
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckAPitchNegative.ToggleOn(TRUE);
					}
					
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x08, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);

					if(nLength == 3)
					{
							if(port)
							{
								char buf[] = {0x90, 0x08, 0x01, 0x00}; 
								port->WriteByte(buf, 4);
							}
					}
				}
				
				if(emulator)
				{
					emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_OFF);
					emulator->DeckAPitchNegative.ToggleOn(TRUE);
				}
				
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPitchNumberf(float fNumber)
{
	if(bInitialized)
	{
		if(fNumber <= 19.9f && fNumber >= -19.9f)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			CString cszDigitOne;
			CString cszDigitTwo;
			CString cszDigitThree;
			CString cszDigitFour;
			
			float fNumberCopy = fNumber;
			if(fNumber < 0.0f)
				fNumber = fNumber*-1;
			
			
			CString cszNumber;
			cszNumber.Format("%.1f", fNumber);
			
			int nLength = cszNumber.GetLength();
			
			
			if(nLength == 4)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				//cszDigitThree = cszNumber.GetAt(2);
				cszDigitFour = cszNumber.GetAt(3);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				//BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x08, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
					emulator->DeckAPitchDigitOne.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x09, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckAPitchDigitTwo.ToggleOn(TRUE);
				}
				
				//decimal
				if(port)
				{
					char buf3[] = {0x90, 0x0B, 0x0E, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_ON);
					emulator->DeckAPitchDecimal.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf4[] = {0x90, 0x0A, xDigitFour, 0x00}; 
					port->WriteByte(buf4, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitFour)]);
					emulator->DeckAPitchDigitThree.ToggleOn(TRUE);
				}
				
			}
			else if(nLength == 3)
			{
				cszDigitOne = cszNumber.GetAt(0);
				//cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);
				//cszDigitFour = cszNumber.GetAt(3);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				//BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				//BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				//port->WriteByte(0x90);
				//port->WriteByte(0x08);
				//port->WriteByte(xDigitOne);
				
				if(port)
				{
					char buf[] = {0x90, 0x09, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckAPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					//clear the 1
					char buf[] = {0x90, 0x08, 0x02, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(emulator)
				{
					emulator->DeckAPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckAPitchDigitOne.ToggleOn(FALSE);
				}

				//decimal
				if(port)
				{
					char buf2[] = {0x90, 0x0B, 0x0E, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_ON);
					emulator->DeckAPitchDecimal.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf3[] = {0x90, 0x0A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				if(emulator)
				{
					emulator->DeckAPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitThree)]);
					emulator->DeckAPitchDigitThree.ToggleOn(TRUE);
				}
			}
			
			
			if(fNumberCopy < 0)
			{
				if(nLength == 4)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
						emulator->DeckAPitchDigitThree.ToggleOn(TRUE);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckAPitchNegative.ToggleOn(TRUE);
					}
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckAPitchNegative.ToggleOn(TRUE);
					}
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x08, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(nLength == 4)
				{
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x01, 0x00}; 
						port->WriteByte(buf, 4);
					}
				}
				
				if(emulator)
				{
					emulator->DeckAPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_OFF);
					emulator->DeckAPitchNegative.ToggleOn(TRUE);
				}
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetProgress(int nPercent)
{
	if(bInitialized)
	{
		//there are 5 slots left and 5 slots right
		//for a total of 10 so we must do it right
		int nScalePercent = nPercent / 10;
		if(nScalePercent == 1)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x30, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[0].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[0].ToggleOn(TRUE);
			}
			
		}
		else if(nScalePercent == 2)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x38, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[1].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[1].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 3)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[2].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[2].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 4)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[3].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[3].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 5)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[4].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[4].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 6)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x50, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[5].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[5].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 7)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x58, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[6].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[6].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 8)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[7].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[7].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 9)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[8].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[8].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 10)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckAProgress[9].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckAProgress[9].ToggleOn(TRUE);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_ClearProgress()
{
	if(bInitialized)
	{
		if(port)
		{
			char buf[] = {0x90, 0x0F, 0x20, 0x00}; 
			port->WriteByte(buf, 4);
		}
		
		
		if(port)
		{
			char buf2[] = {0x90, 0x0F, 0x00, 0x00}; 
			port->WriteByte(buf2, 4);
		}
		
		for(int i=0; i<10; i++)
		{
			if(emulator)
			{
				emulator->DeckAProgress[i].SetToggleBitmap("", IDB_PROGRESS_OFF);
				emulator->DeckAProgress[i].ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetCueLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckA_SetFlashCueLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckACueLight.SetToggleBitmap("", IDB_CUELIGHT_ON);
				emulator->m_btnDeckACueLight.ToggleOn(TRUE);
			}

			bDeckACueLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckACueLight.SetToggleBitmap("", IDB_CUELIGHT_OFF);
				emulator->m_btnDeckACueLight.ToggleOn(TRUE);
			}

			bDeckACueLightOn = FALSE;
			DAC2_DeckA_SetFlashCueLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetCueLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckACueLight.SetToggleBitmap("", IDB_CUELIGHT_ON);
				emulator->m_btnDeckACueLight.ToggleOn(TRUE);
			}

			bDeckACueLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckACueLight.SetToggleBitmap("", IDB_CUELIGHT_OFF);
				emulator->m_btnDeckACueLight.ToggleOn(TRUE);
			}

			bDeckACueLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPlayLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckA_SetFlashPlayLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_ON);
				emulator->m_btnDeckAPlayLight.ToggleOn(TRUE);
			}
			bDeckAPlayLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(emulator)
			{
				emulator->m_btnDeckAPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_OFF);
				emulator->m_btnDeckAPlayLight.ToggleOn(TRUE);
			}

			bDeckAPlayLightOn = FALSE;
			DAC2_DeckA_SetFlashPlayLight(FALSE);
		}	
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetPlayLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_ON);
				emulator->m_btnDeckAPlayLight.ToggleOn(TRUE);
			}
			bDeckAPlayLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(emulator)
			{
				emulator->m_btnDeckAPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_OFF);
				emulator->m_btnDeckAPlayLight.ToggleOn(TRUE);
			}

			bDeckAPlayLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetFXLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x09, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAFXLight.SetToggleBitmap("", IDB_FXLIGHT_ON);
				emulator->m_btnDeckAFXLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x09, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAFXLight.SetToggleBitmap("", IDB_FXLIGHT_OFF);
				emulator->m_btnDeckAFXLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetMatchLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x02, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAMatchLight.SetToggleBitmap("", IDB_MATCHLIGHT_ON);
				emulator->m_btnDeckAMatchLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x02, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckAMatchLight.SetToggleBitmap("", IDB_MATCHLIGHT_OFF);
				emulator->m_btnDeckAMatchLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetLoopLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x08, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckALoopLight.SetToggleBitmap("", IDB_LOOPLIGHT_ON);
				emulator->m_btnDeckALoopLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x08, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckALoopLight.SetToggleBitmap("", IDB_LOOPLIGHT_OFF);
				emulator->m_btnDeckALoopLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetFlashPlayLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckAPlayFlashTimer)
				dwDeckAPlayFlashTimer = timeSetEvent(250,250,&DeckAPlayFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckAPlayFlashTimer)
				timeKillEvent(dwDeckAPlayFlashTimer);

			dwDeckAPlayFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetFlashCueLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckACueFlashTimer)
				dwDeckACueFlashTimer = timeSetEvent(250,250,&DeckACueFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckACueFlashTimer)
				timeKillEvent(dwDeckACueFlashTimer);

			dwDeckACueFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

//DECK B


BOOL WINEXPORT DAC2_DeckB_SetCueNumber(int nNumber)
{
	if(bInitialized)
	{
		//leftnum  900000-90000B
		//rightnum 900100-90010B
		if(nNumber == -1)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x10, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBCueDigitOne.SetToggleBitmap("", IDB_LARGE_BLANK);
				emulator->DeckBCueDigitOne.ToggleOn(TRUE);
				emulator->DeckBCueDigitTwo.SetToggleBitmap("", IDB_LARGE_BLANK);
				emulator->DeckBCueDigitTwo.ToggleOn(TRUE);
			}
			
		}
		else if(nNumber == -2)
		{
			//set them to - -
			if(port)
			{
				char buf[] = {0x90, 0x10, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBCueDigitOne.SetToggleBitmap("", IDB_LARGE_DASH);
				emulator->DeckBCueDigitOne.ToggleOn(TRUE);
				emulator->DeckBCueDigitTwo.SetToggleBitmap("", IDB_LARGE_DASH);
				emulator->DeckBCueDigitTwo.ToggleOn(TRUE);
			}
		}
		else if(nNumber <= 99)
		{
			//set them to the number provided
			//ok get the number and parse it
			CString cszNumber;
			cszNumber.Format("%02d", nNumber);
			
			CString cszDigitOne = cszNumber.GetAt(0);
			CString cszDigitTwo = cszNumber.GetAt(1);
			
			BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
			BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x10, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				
				//figure out the bitmap
				emulator->DeckBCueDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
				emulator->DeckBCueDigitOne.ToggleOn(TRUE);
				emulator->DeckBCueDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
				emulator->DeckBCueDigitTwo.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetColons(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x1D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckBTimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckBTimeColonOne.ToggleOn(TRUE);
				
				emulator->DeckBTimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckBTimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_ON);
				emulator->DeckBTimeColonTwo.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x1D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckBTimeColonOne.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckBTimeColonOne.ToggleOn(TRUE);
				
				emulator->DeckBTimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckBTimeColonTwo.SetToggleBitmap("", IDB_SMALL_COLON_OFF);
				emulator->DeckBTimeColonTwo.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetTime(int nMinutes, int nSeconds, int nMilliseconds)
{
	if(bInitialized)
	{
		CString cszNumber;
		CString cszDigitOne, cszDigitTwo;
		BYTE xDigitOne, xDigitTwo;
		
		//minutes
		if(nMinutes == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x12, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitOne.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitTwo.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else if(nMinutes == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x12, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitOne.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitTwo.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else if(nMinutes <= 99)
		{
			cszNumber;
			cszNumber.Format("%02d", nMinutes);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x12, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitOne.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckBTimeDigitOne.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitTwo.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckBTimeDigitTwo.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//seconds
		if(nSeconds == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x14, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitThree.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitFour.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitFour.ToggleOn(TRUE);
			}
		}
		else if(nSeconds == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x14, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitThree.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitFour.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitFour.ToggleOn(TRUE);
			}
		}
		else if(nSeconds <= 99)
		{
			cszNumber.Format("%02d", nSeconds);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x14, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitThree.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckBTimeDigitThree.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitFour.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckBTimeDigitFour.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//milliseconds
		if(nMilliseconds == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x16, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitFive.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitSix.SetToggleBitmap("", IDB_SMALL_BLANK);
				emulator->DeckBTimeDigitSix.ToggleOn(TRUE);
			}
		}
		else if(nMilliseconds == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x16, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitFive.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitSix.SetToggleBitmap("", IDB_SMALL_DASH);
				emulator->DeckBTimeDigitSix.ToggleOn(TRUE);
			}
		}
		else if(nMilliseconds <= 99)
		{
			cszNumber.Format("%02d", nMilliseconds);
			
			//digit one 900200-90020B
			//digit two 900300-90030B
			cszDigitOne = cszNumber.GetAt(0);
			cszDigitTwo = cszNumber.GetAt(1);
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x16, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBTimeDigitFive.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitOne)]);
				emulator->DeckBTimeDigitFive.ToggleOn(TRUE);
				
				emulator->DeckBTimeDigitSix.SetToggleBitmap("", arySmallNumbers[atoi(cszDigitTwo)]);
				emulator->DeckBTimeDigitSix.ToggleOn(TRUE);
			}
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetElapsed(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x16, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBElapsed.SetToggleBitmap("", IDB_ELAPSED_ON);
				emulator->DeckBElapsed.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x16, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBElapsed.SetToggleBitmap("", IDB_ELAPSED_OFF);
				emulator->DeckBElapsed.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetRemain(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x17, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBRemain.SetToggleBitmap("", IDB_REMAIN_ON);
				emulator->DeckBRemain.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x17, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBRemain.SetToggleBitmap("", IDB_REMAIN_OFF);
				emulator->DeckBRemain.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetSingle(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x15, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBSingle.SetToggleBitmap("", IDB_SINGLE_ON);
				emulator->DeckBSingle.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x15, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBSingle.SetToggleBitmap("", IDB_SINGLE_OFF);
				emulator->DeckBSingle.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPitchNumber(int nNumber)
{
	if(bInitialized)
	{
		if(nNumber <= 199 && nNumber >= -199)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			CString cszDigitOne;
			CString cszDigitTwo;
			CString cszDigitThree;
			
			int nNumberCopy = nNumber;
			nNumber = abs(nNumber);
			
			
			CString cszNumber;
			cszNumber.Format("%02d", nNumber);
			
			int nLength = cszNumber.GetLength();
			
			//Clear the decimal
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x1E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_OFF);
				emulator->DeckBPitchDecimal.ToggleOn(TRUE);
			}
			
			
			if(nLength == 3)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x18, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckBPitchDigitOne.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x19, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckBPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf3[] = {0x90, 0x1A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitThree)]);
					emulator->DeckBPitchDigitThree.ToggleOn(TRUE);
				}
				
			}
			else if(nLength == 2)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				
				//clear the 1
				////port->writeByte(0x90);
				////port->writeByte(0x08);
				////port->writeByte(0x00);

				if(port)
				{
					//clear the 1
					char buf[] = {0x90, 0x18, 0x02, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(emulator)
				{
					emulator->DeckBPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckBPitchDigitOne.ToggleOn(FALSE);
				}
				
				if(port)
				{
					char buf[] = {0x90, 0x19, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckBPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x1A, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckBPitchDigitThree.ToggleOn(TRUE);
				}
			}
			
			
			if(nNumberCopy < 0)
			{
				if(nLength == 3)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckBPitchNegative.ToggleOn(TRUE);
					}
					
					if(emulator)
					{
						emulator->DeckBPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
						emulator->DeckBPitchDigitOne.ToggleOn(TRUE);
					}
				}
				else
				{
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					//show negative
					
					if(emulator)
					{
						emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckBPitchNegative.ToggleOn(TRUE);
					}
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x18, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(nLength == 3)
				{
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x01, 0x00}; 
						port->WriteByte(buf, 4);
					}
				}

				if(emulator)
				{
					emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_OFF);
					emulator->DeckBPitchNegative.ToggleOn(TRUE);
				}
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPitchNumberf(float fNumber)
{
	if(bInitialized)
	{
		if(fNumber <= 19.9f && fNumber >= -19.9f)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			CString cszDigitOne;
			CString cszDigitTwo;
			CString cszDigitThree;
			CString cszDigitFour;
			
			float fNumberCopy = fNumber;
			if(fNumber < 0.0f)
				fNumber = fNumber*-1;
			
			
			CString cszNumber;
			cszNumber.Format("%.1f", fNumber);
			
			int nLength = cszNumber.GetLength();
			
			
			if(nLength == 4)
			{
				cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				//cszDigitThree = cszNumber.GetAt(2);
				cszDigitFour = cszNumber.GetAt(3);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				//BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x18, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
					emulator->DeckBPitchDigitOne.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x19, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitTwo)]);
					emulator->DeckBPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf3[] = {0x90, 0x0B, 0x1E, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				//decimal
				if(emulator)
				{
					emulator->DeckBPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_ON);
					emulator->DeckBPitchDecimal.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf4[] = {0x90, 0x1A, xDigitFour, 0x00}; 
					port->WriteByte(buf4, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitFour)]);
					emulator->DeckBPitchDigitThree.ToggleOn(TRUE);
				}
				
			}
			else if(nLength == 3)
			{
				cszDigitOne = cszNumber.GetAt(0);
				//cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);
				//cszDigitFour = cszNumber.GetAt(3);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				//BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				//BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				////port->writeByte(0x90);
				////port->writeByte(0x08);
				////port->writeByte(xDigitOne);

				if(port)
				{
					//clear the 1
					char buf[] = {0x90, 0x18, 0x02, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(emulator)
				{
					emulator->DeckBPitchDigitOne.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckBPitchDigitOne.ToggleOn(FALSE);
				}
				
				if(port)
				{
					char buf[] = {0x90, 0x19, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitTwo.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitOne)]);
					emulator->DeckBPitchDigitTwo.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x0B, 0x1E, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				//decimal
				if(emulator)
				{
					emulator->DeckBPitchDecimal.SetToggleBitmap("", IDB_PITCH_DECIMAL_ON);
					emulator->DeckBPitchDecimal.ToggleOn(TRUE);
				}
				
				if(port)
				{
					char buf3[] = {0x90, 0x1A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				if(emulator)
				{
					emulator->DeckBPitchDigitThree.SetToggleBitmap("", aryLargeNumbers[atoi(cszDigitThree)]);
					emulator->DeckBPitchDigitThree.ToggleOn(TRUE);
				}
			}
			
			
			if(fNumberCopy < 0)
			{
				if(nLength == 4)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckBPitchDigitOne.SetToggleBitmap("", IDB_PITCH_ONE_ON);
						emulator->DeckBPitchDigitThree.ToggleOn(TRUE);
					}
					
					if(emulator)
					{
						emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckBPitchNegative.ToggleOn(TRUE);
					}
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
					if(emulator)
					{
						emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_ON);
						emulator->DeckBPitchNegative.ToggleOn(TRUE);
					}
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x18, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}

				if(nLength == 4)
				{
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x01, 0x00}; 
						port->WriteByte(buf, 4);
					}
				}
				
				if(emulator)
				{
					emulator->DeckBPitchNegative.SetToggleBitmap("", IDB_PITCH_NEGATIVE_OFF);
					emulator->DeckBPitchNegative.ToggleOn(TRUE);
				}
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetProgress(int nPercent)
{
	if(bInitialized)
	{
		//there are 5 slots left and 5 slots right
		//for a total of 10 so we must do it right

		int nScalePercent = nPercent / 10;
		if(nScalePercent == 1)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x30, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[0].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[0].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 2)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x38, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[1].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[1].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 3)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[2].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[2].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 4)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[3].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[3].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 5)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[4].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[4].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 6)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x50, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[5].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[5].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 7)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x58, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[6].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[6].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 8)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[7].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[7].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 9)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[8].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[8].ToggleOn(TRUE);
			}
		}
		else if(nScalePercent == 10)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->DeckBProgress[9].SetToggleBitmap("", IDB_PROGRESS_ON);
				emulator->DeckBProgress[9].ToggleOn(TRUE);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_ClearProgress()
{
	if(bInitialized)
	{
		if(port)
		{
			char buf[] = {0x90, 0x1F, 0x20, 0x00}; 
			port->WriteByte(buf, 4);
		}
		
		
		if(port)
		{
			char buf2[] = {0x90, 0x1F, 0x00, 0x00}; 
			port->WriteByte(buf2, 4);
		}
		
		for(int i=0; i<10; i++)
		{
			if(emulator)
			{
				emulator->DeckBProgress[i].SetToggleBitmap("", IDB_PROGRESS_OFF);
				emulator->DeckBProgress[i].ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPlayLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckB_SetFlashPlayLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_ON);
				emulator->m_btnDeckBPlayLight.ToggleOn(TRUE);
			}
			
			bDeckBPlayLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_OFF);
				emulator->m_btnDeckBPlayLight.ToggleOn(TRUE);
			}
			
			bDeckBPlayLightOn = FALSE;
			DAC2_DeckB_SetFlashPlayLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckB_SetPlayLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_ON);
				emulator->m_btnDeckBPlayLight.ToggleOn(TRUE);
			}

			bDeckBPlayLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBPlayLight.SetToggleBitmap("", IDB_PLAYLIGHT_OFF);
				emulator->m_btnDeckBPlayLight.ToggleOn(TRUE);
			}

			bDeckBPlayLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetCueLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckB_SetFlashCueLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBCueLight.SetToggleBitmap("", IDB_CUELIGHT_ON);
				emulator->m_btnDeckBCueLight.ToggleOn(TRUE);
			}

			bDeckBCueLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBCueLight.SetToggleBitmap("", IDB_CUELIGHT_OFF);
				emulator->m_btnDeckBCueLight.ToggleOn(TRUE);
			}

			bDeckBCueLightOn = FALSE;
			DAC2_DeckB_SetFlashCueLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckB_SetCueLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBCueLight.SetToggleBitmap("", IDB_CUELIGHT_ON);
				emulator->m_btnDeckBCueLight.ToggleOn(TRUE);
			}

			bDeckBCueLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBCueLight.SetToggleBitmap("", IDB_CUELIGHT_OFF);
				emulator->m_btnDeckBCueLight.ToggleOn(TRUE);
			}

			bDeckBCueLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetFXLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBFXLight.SetToggleBitmap("", IDB_FXLIGHT_ON);
				emulator->m_btnDeckBFXLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBFXLight.SetToggleBitmap("", IDB_FXLIGHT_OFF);
				emulator->m_btnDeckBFXLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetMatchLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBMatchLight.SetToggleBitmap("", IDB_MATCHLIGHT_ON);
				emulator->m_btnDeckBMatchLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBMatchLight.SetToggleBitmap("", IDB_MATCHLIGHT_OFF);
				emulator->m_btnDeckBMatchLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetLoopLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBLoopLight.SetToggleBitmap("", IDB_LOOPLIGHT_ON);
				emulator->m_btnDeckBLoopLight.ToggleOn(TRUE);
			}
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(emulator)
			{
				emulator->m_btnDeckBLoopLight.SetToggleBitmap("", IDB_LOOPLIGHT_OFF);
				emulator->m_btnDeckBLoopLight.ToggleOn(TRUE);
			}
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}



BOOL DAC2_DeckB_SetFlashPlayLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckBPlayFlashTimer)
				dwDeckBPlayFlashTimer = timeSetEvent(250,250,&DeckBPlayFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckBPlayFlashTimer)
				timeKillEvent(dwDeckBPlayFlashTimer);

			dwDeckBPlayFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckB_SetFlashCueLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckBCueFlashTimer)
				dwDeckBCueFlashTimer = timeSetEvent(250,250,&DeckBCueFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckBCueFlashTimer)
				timeKillEvent(dwDeckBCueFlashTimer);

			dwDeckBCueFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}









BOOL WINEXPORT DAC2_SetCueNumber(int nDevice, int nNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueNumber(nNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueNumber(nNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetColons(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetColons(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetColons(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetTime(int nDevice, int nMinutes, int nSeconds, int nMilliseconds)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetTime(nMinutes, nSeconds, nMilliseconds);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetTime(nMinutes, nSeconds, nMilliseconds);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetElapsed(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetElapsed(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetElapsed(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetRemain(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetRemain(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetRemain(bShow);
	}

	return FALSE;
}


BOOL WINEXPORT DAC2_SetSingle(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetSingle(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetSingle(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPitchNumber(int nDevice, int nNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPitchNumber(nNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPitchNumber(nNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPitchNumberf(int nDevice, float fNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPitchNumberf(fNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPitchNumberf(fNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetProgress(int nDevice, int nPercent)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetProgress(nPercent);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetProgress(nPercent);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_ClearProgress(int nDevice)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_ClearProgress();
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_ClearProgress();
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetCueLight(int nDevice, int nState)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueLight(nState);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueLight(nState);
	}

	return FALSE;
}

BOOL DAC2_SetCueLightB(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueLightB(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueLightB(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPlayLight(int nDevice, int nState)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPlayLight(nState);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPlayLight(nState);
	}

	return FALSE;
}

BOOL DAC2_SetPlayLightB(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPlayLightB(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPlayLightB(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetFXLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFXLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetFXLight(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetMatchLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetMatchLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetMatchLight(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetLoopLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetLoopLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetLoopLight(bOn);
	}

	return FALSE;
}

BOOL DAC2_SetFlashPlayLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFlashPlayLight(bOn);
	}
	else if(nDevice == 1)
	{
		return DAC2_DeckB_SetFlashPlayLight(bOn);
	}
	
	return TRUE;
}

BOOL DAC2_SetFlashCueLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFlashCueLight(bOn);
	}
	else if(nDevice == 1)
	{
		return DAC2_DeckB_SetFlashCueLight(bOn);
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_SetEmulatorWindowPos(int nLeft, int nTop)
{
	if(emulator)
		emulator->SetWindowPos(NULL, nLeft, nTop, 0, 0, SWP_NOSIZE);

	return TRUE;
}