#ifndef DAC2_H
#define DAC2_H

#ifdef __cplusplus
extern "C" {
#endif

#define	DAC2_OK			0	// all is OK
#define DAC2_ERROR_INIT		1	// DAC-2 is not initialized
#define DAC2_ERROR_PORT		2	// can't open com port
#define DAC2_ERROR_THREAD	3	// can't start serial event thread
#define DAC2_ERROR_DEVICE	4	// can't find a valid PCDJ DAC-2 Device
#define DAC2_ERROR_RANGE	5	// number out of range

#define DAC2_LOAD_DOWN				2000
#define DAC2_LOAD_UP				2001
#define	DAC2_CUE_DOWN				2002
#define DAC2_CUE_UP				2003
#define DAC2_PLAY_DOWN				2004
#define DAC2_PLAY_UP				2005
#define DAC2_WAIT_DOWN				2006
#define DAC2_WAIT_UP				2007
#define DAC2_SHIFT_DOWN				2008
#define DAC2_SHIFT_UP				2009
#define DAC2_FX_DOWN				2010
#define DAC2_FX_UP				2011
#define DAC2_CUE_LEFT_DOWN			2012
#define DAC2_CUE_LEFT_UP			2013
#define DAC2_CUE_RIGHT_DOWN			2014
#define DAC2_CUE_RIGHT_UP			2015
#define DAC2_GROUP_DOWN				2016
#define DAC2_GROUP_UP				2017
#define DAC2_LOOP_DOWN				2018
#define DAC2_LOOP_UP				2019
#define DAC2_MATCH_DOWN				2020
#define DAC2_MATCH_UP				2021
#define DAC2_PITCHBEND_PLUS_DOWN		2022
#define DAC2_PITCHBEND_PLUS_UP			2023
#define DAC2_PITCHBEND_MINUS_DOWN		2024
#define DAC2_PITCHBEND_MINUS_UP			2025
#define DAC2_PITCH_SLIDER			2026 //uses dwValue parameter for position
#define DAC2_JOG_LEFT				2027
#define DAC2_JOG_RIGHT				2028
#define DAC2_SEEK_START				2029 //seeking started
#define DAC2_SEEK_END				2030 //seeking ended
#define DAC2_SEEK_FWD_1_ON			2031
#define DAC2_SEEK_FWD_1_OFF			2032
#define DAC2_SEEK_FWD_2_ON			2033
#define DAC2_SEEK_FWD_2_OFF			2034
#define DAC2_SEEK_FWD_3_ON			2035
#define DAC2_SEEK_FWD_3_OFF			2036
#define DAC2_SEEK_FWD_4_ON			2037
#define DAC2_SEEK_FWD_4_OFF			2038
#define DAC2_SEEK_FWD_5_ON			2039
#define DAC2_SEEK_FWD_5_OFF			2040
#define DAC2_SEEK_FWD_6_ON			2041
#define DAC2_SEEK_FWD_6_OFF			2042
#define DAC2_SEEK_FWD_7_ON			2055
#define DAC2_SEEK_FWD_7_OFF			2056
#define DAC2_SEEK_REV_1_ON			2043
#define DAC2_SEEK_REV_1_OFF			2044
#define DAC2_SEEK_REV_2_ON			2045
#define DAC2_SEEK_REV_2_OFF			2046
#define DAC2_SEEK_REV_3_ON			2047
#define DAC2_SEEK_REV_3_OFF			2048
#define DAC2_SEEK_REV_4_ON			2049
#define DAC2_SEEK_REV_4_OFF			2050
#define DAC2_SEEK_REV_5_ON			2051
#define DAC2_SEEK_REV_5_OFF			2052
#define DAC2_SEEK_REV_6_ON			2053
#define DAC2_SEEK_REV_6_OFF			2054
#define DAC2_SEEK_REV_7_ON			2057
#define DAC2_SEEK_REV_7_OFF			2058
#define DAC2_SEEK_REV_8_ON			2059
#define DAC2_SEEK_REV_8_OFF			2060

typedef void (CALLBACK DAC2PROC)(DWORD dwAction, DWORD dwValue, DWORD user);

#ifndef DAC2DEF
#define DAC2DEF(f) WINAPI f
#endif
BOOL   DAC2DEF(DAC2_AutoInit)();
BOOL   DAC2DEF(DAC2_Init)(LPCTSTR=NULL);
BOOL   DAC2DEF(DAC2_EventCallbackSet)(DAC2PROC*,DAC2PROC*,DWORD);
DWORD  DAC2DEF(DAC2_ErrorGetCode)();
BOOL   DAC2DEF(DAC2_Free)();
BOOL   DAC2DEF(DAC2_DeckA_SetCueNumber)(int);
BOOL   DAC2DEF(DAC2_DeckA_SetColons)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetTime)(int,int,int);
BOOL   DAC2DEF(DAC2_DeckA_SetElapsed)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetRemain)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetSingle)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetPitchNumber)(int);
BOOL   DAC2DEF(DAC2_DeckA_SetPitchNumberf)(float);
BOOL   DAC2DEF(DAC2_DeckA_SetProgress)(int);
BOOL   DAC2DEF(DAC2_DeckA_ClearProgress)();
BOOL   DAC2DEF(DAC2_DeckA_SetCueLight)(int);
BOOL   DAC2DEF(DAC2_DeckA_SetPlayLight)(int);
BOOL   DAC2DEF(DAC2_DeckA_SetFXLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetMatchLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetLoopLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetFlashPlayLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckA_SetFlashCueLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetCueNumber)(int);
BOOL   DAC2DEF(DAC2_DeckB_SetColons)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetTime)(int,int,int);
BOOL   DAC2DEF(DAC2_DeckB_SetElapsed)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetRemain)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetSingle)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetPitchNumber)(int);
BOOL   DAC2DEF(DAC2_DeckB_SetPitchNumberf)(float);
BOOL   DAC2DEF(DAC2_DeckB_SetProgress)(int);
BOOL   DAC2DEF(DAC2_DeckB_ClearProgress)();
BOOL   DAC2DEF(DAC2_DeckB_SetCueLight)(int);
BOOL   DAC2DEF(DAC2_DeckB_SetPlayLight)(int);
BOOL   DAC2DEF(DAC2_DeckB_SetFXLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetMatchLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetLoopLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetFlashPlayLight)(BOOL);
BOOL   DAC2DEF(DAC2_DeckB_SetFlashCueLight)(BOOL);
BOOL   DAC2DEF(DAC2_SetCueNumber)(int, int);
BOOL   DAC2DEF(DAC2_SetColons)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetTime)(int,int,int,int);
BOOL   DAC2DEF(DAC2_SetElapsed)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetRemain)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetSingle)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetPitchNumber)(int,int);
BOOL   DAC2DEF(DAC2_SetPitchNumberf)(int,float);
BOOL   DAC2DEF(DAC2_SetProgress)(int,int);
BOOL   DAC2DEF(DAC2_ClearProgress)(int);
BOOL   DAC2DEF(DAC2_SetCueLight)(int,int);
BOOL   DAC2DEF(DAC2_SetPlayLight)(int,int);
BOOL   DAC2DEF(DAC2_SetFXLight)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetMatchLight)(int,BOOL);
BOOL   DAC2DEF(DAC2_SetLoopLight)(int,BOOL);




#ifdef __cplusplus
}
#endif

#endif